LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY DDR2_Test_TB IS
END DDR2_Test_TB;
 
ARCHITECTURE behavior OF DDR2_Test_TB IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT DDR2_Test_Top
    PORT(
         CLK_P : IN  std_logic;
         CLK_N : IN  std_logic;
         ENABLE : IN  std_logic;
         RES : IN  std_logic;
         LED_BLINK : OUT  std_logic;
         LED_DDR2 : OUT  std_logic;
         LED_CALIB : OUT  std_logic;
         INTF_RST : OUT  std_logic;
         INTF_WR_EN : OUT  std_logic;
         INTF_WR_ER : OUT  std_logic;
         INTF_WR_EM : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal CLK_P : std_logic := '0';
   signal CLK_N : std_logic := '0';
   signal ENABLE : std_logic := '0';
   signal RES : std_logic := '0';

 	--Outputs
   signal LED_BLINK : std_logic;
   signal LED_DDR2 : std_logic;
   signal LED_CALIB : std_logic;
   signal INTF_RST : std_logic;
   signal INTF_WR_EN : std_logic;
   signal INTF_WR_ER : std_logic;
   signal INTF_WR_EM : std_logic;

   -- Clock period definitions
   constant CLK_P_period : time := 5 ns;
   constant CLK_N_period : time := 5 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: DDR2_Test_Top PORT MAP (
          CLK_P => CLK_P,
          CLK_N => CLK_N,
          ENABLE => ENABLE,
          RES => RES,
          LED_BLINK => LED_BLINK,
          LED_DDR2 => LED_DDR2,
          LED_CALIB => LED_CALIB,
          INTF_RST => INTF_RST,
          INTF_WR_EN => INTF_WR_EN,
          INTF_WR_ER => INTF_WR_ER,
          INTF_WR_EM => INTF_WR_EM
        );

   -- Clock process definitions
   CLK_P_process :process
   begin
		CLK_P <= '0'; wait for CLK_P_period/2;
		CLK_P <= '1'; wait for CLK_P_period/2;
   end process;
 
   CLK_N_process :process
   begin
		CLK_N <= '1'; wait for CLK_N_period/2;
		CLK_N <= '0'; wait for CLK_N_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
		ENABLE <= '0';
		RES <= '0';
		
		wait for 150 ns;	
		RES <= '0';
		ENABLE <= '1';

      -- insert stimulus here 

      wait;
   end process;

END;
